from time import sleep
from hytest import *
# 获取当前脚本的绝对路径
current_dir = os.path.dirname(os.path.abspath(__file__))
# 构建预定系统的绝对路径
预定系统_path = os.path.abspath(os.path.join(current_dir, '..','..','..','..'))
# 添加路径
sys.path.append(预定系统_path)
# 导入模块
try:
    from 预定系统.Base.base import *
except ModuleNotFoundError as e:
    print(f"ModuleNotFoundError: {e}")
    print("尝试使用绝对路径导入")
    from 预定系统.Base.base import *

# 获取当前脚本所在的目录
current_dir = os.path.dirname(os.path.abspath(__file__))

# 构建CSV文件的绝对路径
csv_file_path = os.path.join(current_dir, '../../../测试数据/会议室管理/会议室管理模块/会议室新增.csv')

class Conference_Add_000x:

    ddt_cases = read_csv_data(csv_file_path)

    def teststeps(self):
        """
            执行测试步骤以会议室新增功能。
            本函数根据参数输入会议室名称、，并检查新增后的提示信息是否与预期相符。
        """
        # 初始化通知文本为空字符串
        notify_text = ""
        # 从全局存储中获取webdriver实例
        wd = GSTORE['wd']
        # 从self.para中解构出用户名、密码、验证码和检查文本
        name = self.name
        conference_name, conference_token, conference_function, conference_capacity, check_text, back_check_text = self.para

        if back_check_text == "添加成功":
            STEP(1, "点击【新增】按钮")
            safe_click((By.XPATH, "//span[contains(text(),'添 加')]"), wd)
            sleep(1)
            notify_text = elment_get_text((By.XPATH, "//span[contains(text(),'新增会议室')]"), wd)
            INFO(f"检查新增会议室弹窗标题是否为：{notify_text}")

        STEP(2, f"输入会议室名称：{conference_name}")
        safe_send_keys((By.XPATH,"//input[@placeholder='输入会议室名称']"),conference_name,wd)
        sleep(1)

        STEP(3, f"绑定会议室授权码：{conference_token}")
        safe_click((By.XPATH,"(//input[@placeholder='请选择'])[1]"),wd)
        safe_click((By.XPATH,f"//span[normalize-space()='{conference_token}']"),wd)
        sleep(1)

        STEP(4, f"选择会议室功能：{conference_function}")
        safe_click((By.XPATH,"(//span[contains(text(),'设置(0)')])[1]"),wd)
        sleep(1)
        notify_text = elment_get_text((By.XPATH,"//span[contains(text(),'会议室功能')]"),wd)
        INFO(f"检查会议室功能设置弹窗标题是否为：{notify_text}")
        CHECK_POINT("检查是否弹出功能设置弹窗",notify_text == "会议室功能")

        STEP(5, f"搜索会议室功能：{conference_function}")
        safe_send_keys((By.XPATH,"(//input[@placeholder='输入关键字'])[1]"),conference_function,wd)
        send_keyboard((By.XPATH,"(//input[@placeholder='输入关键字'])[1]"),wd)
        sleep(1)
        notify_text = elment_get_text((By.XPATH,f"//span[contains(text(),'{conference_function}')]"),wd)
        INFO(f"检查是否搜索到功能：{notify_text}")
        CHECK_POINT("检查是否搜索到功能",notify_text == conference_function)

        STEP(6, "勾选功能进行绑定")
        safe_click((By.XPATH,f"//span[contains(text(),'{conference_function}')]"),wd)
        safe_click((By.XPATH,"//i[@class='el-icon-arrow-right']"),wd)
        sleep(1)

        STEP(7, f"查看功能选择结果")
        notify_text = elment_get_text((By.XPATH,"(//p[contains(text(),'无匹配数据')])[1]"),wd)
        INFO(f"检查左侧列表是否清空：{notify_text}")
        CHECK_POINT("检查左侧列表是否清空",notify_text == "无匹配数据")

        notify_text = elment_get_text((By.XPATH,f"//span[contains(text(),'{conference_function}')]"),wd)
        INFO(f"检查右侧列表是否绑定功能：{notify_text}")
        CHECK_POINT("检查右侧列表是否绑定功能",notify_text == conference_function)

        STEP(8, "会议室功能界面点击【确定】按钮")
        safe_click((By.XPATH,"//div[@aria-label='会议室功能']//span[contains(text(),'确定')]"),wd)

        STEP(9, f"输入会议室容纳人数：{conference_capacity}")
        safe_send_keys((By.XPATH,"//input[@placeholder='2']"),conference_capacity,wd)

        STEP(10, "会议室新增界面点击【保存】按钮")
        safe_click((By.XPATH,"//span[contains(text(),'保 存')]"),wd)
        sleep(2)

        if conference_name == "":
            STEP(11, f"检查新增结果是否为：{check_text}")
            notify_text = get_notify_text(wd, (By.XPATH, "//p[@class='el-message__content']"), "Conference_Manage","Conference_Add", f"{name}_查看提示信息")
            INFO(f"检查新增结果为：{notify_text}")
            CHECK_POINT("检查新增结果", notify_text == check_text)

            STEP(12, "点击【重置】按钮")
            safe_click((By.XPATH,"//span[contains(text(),'重置')]"),wd)
            sleep(1)
            notify_text = elment_get_text((By.XPATH,"//p[contains(text(),'确定重置?')]"),wd)
            INFO(f"检查重置弹窗标题是否为：{notify_text}")
            CHECK_POINT("检查重置弹窗标题", notify_text == "确定重置?")

            STEP(13, "点击【确定】按钮")
            safe_click((By.XPATH,"(//span[contains(text(),'确定')])[12]"),wd)
            sleep(1)

        else:
            STEP(11, f"检查新增结果是否为：{check_text}")
            notify_text = get_notify_text(wd, (By.XPATH, "//p[@class='el-message__content']"), "Conference_Manage",
                                          "Conference_Add", f"{name}_查看提示信息")
            INFO(f"检查新增结果为：{notify_text}")
            CHECK_POINT("检查新增结果", notify_text == check_text)

            STEP(12, f"在会议室列表查询：{conference_name}")
            safe_send_keys((By.XPATH, "//input[@placeholder='输入关键字']"), conference_name, wd)
            send_keyboard((By.XPATH, "//input[@placeholder='输入关键字']"), wd)
            sleep(1)

            STEP(13, f"检查会议室新增后的数据回显")
            sleep(1)
            conference_name_text = elment_get_text((By.XPATH, "//tbody/tr[1]/td[2]/div[1]"),
                                                   wd)

            conference_function_text = elment_get_text(
                (By.XPATH, f"//div[normalize-space()='{conference_function}']"), wd)

            conference_capacity_text = elment_get_text(
                (By.XPATH, f"//div[normalize-space()='{conference_capacity}']"), wd)

            INFO(f"检查新增会议室名称为：{conference_name_text}")
            CHECK_POINT("检查新增会议室名称", conference_name_text == conference_name)

            INFO(f"检查新增会议室功能为：{conference_function_text}")
            CHECK_POINT("检查新增会议室功能", conference_function_text == conference_function)

            INFO(f"检查新增会议室容纳人数为：{conference_capacity_text}")
            CHECK_POINT("检查新增会议室容纳人数", conference_capacity_text == conference_capacity)